/*************************************************************************
caSCADA -- Data acquisition system program based on libmodbus 3.0.6
By Tony R. Kuphaldt
Copyright (C) 2016
Last update April 24, 2016

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

This function reads a single 16-bit integer value from a specified 
Modbus register.

RIGHT NOW IT ISN'T WORKING LIKE I WOULD WISH!
  --> It fails to read any *single* Modbus register with an even absolute address

*************************************************************************/

#include <stdio.h>
#include <modbus.h>		// Necessary for all modbus connection and data read/write functions
#include "cascada.h"

int
read_16int (int address)
{

  int read_count;
  uint16_t out;

  // Reading an "Analog Input" register
  if (address > 30000 && address < 40000)
    read_count = modbus_read_input_registers (Device, address - 30001, 1, &out);

  // Reading a "Holding" register
  else if (address > 40000 && address < 50000)
    read_count = modbus_read_registers (Device, address - 40001, 1, &out);

  // If address is out of range, print an error message
  else
    {
      fprintf (stderr,
	       "Invalid Modbus address for reading a 16-bit integer! \n");
      return 0;
    }

  // If read command is unsuccessful, print an error message
  if (read_count < 1)
    {
      fprintf (stderr, "Unable to read data from the Modbus device! \n");
      return 0;
    }

//   printf("Number of register read = %i  ", read_count);

  return (int) (out);

}
