/*************************************************************************
caSCADA -- Data acquisition system program based on libmodbus
By Tony R. Kuphaldt
Copyright (C) 2015
Last update December 16, 2015

This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 3 of the License, or (at your
option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA


Function: write_datapointer
The purpose of this program is to write pointer addresses to a data file
which may be read by some other application.  Any application given this
pointer and the data structures defined in cascada.h will be able to 
access all the data stored in those structures.

NOTE: THIS FUNCTION IS NOT WORKING PROPERLY (YET).  I HAVE NOT YET FIGURED
OUT HOW TO SUCCESSFULLY SAVE AND RETRIEVE MEMORY POINTERS USING FILES!

*************************************************************************/


#include <stdio.h>
#include <modbus.h>
#include "cascada.h"		// Contains all the declarations specific to caSCADA


int
write_datapointer (void)
{
  FILE *fp;			// Pointer to a FILE type

  // opening the data file "data.dat" write-only
  if ((fp = fopen ("data.dat", "w")) == NULL)
    {
      fprintf (stderr, "Can't open `data.dat' data file \n");	// Do this if the file doesn't exist
      return 2;			// Return value of "2" means we cannot open the file
    }

   // If we can open the "data.dat" file then we write pointer addresses to it.
   // Note: the name of a structure is a pointer to its first element, therefore
   // "f_channel" serves as a pointer for the first element of the f_channel[]
   // array of data structures.
   else
   {
      fwrite (f_channel, sizeof (f_channel), 1, fp);
      fclose (fp);
   }

  return 1;

}


